#ifndef DISPLAY_H  //     
#define DISPLAY_H

#include "main.h"

//   
#define LCD_DDR                DDRD
#define LCD_PORT               PORTD
#define LCD_RESET              7
#define LCD_RS                 6

//  
#define LCD_WIDTH              16
#define LCD_HEIGHT             2

//    
#define LCD_CONTRAST_DEFAULT   40

// 
#define LCD_CMD_CLEAR_DISPLAY               0x01

#define LCD_CMD_ENTRY_MODE_SET              0x04
#define LCD_CMD_ENTRY_MODE_SET_INCR         0x02
#define LCD_CMD_ENTRY_MODE_SET_DECR         0x00
#define LCD_CMD_ENTRY_MODE_SET_SHFTON       0x01
#define LCD_CMD_ENTRY_MODE_SET_SHFTOFF      0x00

#define LCD_CMD_FUNCTION_SET                0x20
#define LCD_CMD_FUNCTION_SET_4BIT           0x00
#define LCD_CMD_FUNCTION_SET_8BIT           0x10
#define LCD_CMD_FUNCTION_SET_1LINES         0x00
#define LCD_CMD_FUNCTION_SET_2LINES         0x08
#define LCD_CMD_FUNCTION_SET_FONT5X8        0x00
#define LCD_CMD_FUNCTION_SET_FONT5X16       0x04
#define LCD_CMD_FUNCTION_SET_IS             0x01

#define LCD_CMD_ONOFF_CONTROL               0x08
#define LCD_CMD_ONOFF_CONTROL_DISPON        0x04
#define LCD_CMD_ONOFF_CONTROL_CURSON        0x02
#define LCD_CMD_ONOFF_CONTROL_CURSOFF       0x00
#define LCD_CMD_ONOFF_CONTROL_BLNKON        0x01
#define LCD_CMD_ONOFF_CONTROL_BLNKOFF       0x00

#define LCD_CMD_OSC_FREQ                    0x10
#define LCD_CMD_OSC_FREQ_BIAS_1_4           0x08
#define LCD_CMD_OSC_FREQ_BIAS_1_5           0x00
#define LCD_CMD_OSC_FREQ_122Hz              0x00
#define LCD_CMD_OSC_FREQ_131Hz              0x01
#define LCD_CMD_OSC_FREQ_144Hz              0x02
#define LCD_CMD_OSC_FREQ_161Hz              0x03
#define LCD_CMD_OSC_FREQ_183Hz              0x04
#define LCD_CMD_OSC_FREQ_221Hz              0x05
#define LCD_CMD_OSC_FREQ_274Hz              0x06
#define LCD_CMD_OSC_FREQ_347Hz              0x07

#define LCD_CMD_CONTRAST_L                  0x70
#define LCD_CMD_CONTRAST_L_MASK             0x0F

#define LCD_CMD_PWR_CONTRAST_H              0x50
#define LCD_CMD_PWR_CONTRAST_H_ICON_ON      0x08
#define LCD_CMD_PWR_CONTRAST_H_ICON_OFF     0x00
#define LCD_CMD_PWR_CONTRAST_H_BOOST_ON     0x04
#define LCD_CMD_PWR_CONTRAST_H_BOOST_OFF    0x00
#define LCD_CMD_PWR_CONTRAST_H_MASK         0x30

#define LCD_CMD_FOLLOWER_CTRL               0x60
#define LCD_CMD_FOLLOWER_CTRL_ON            0x08
#define LCD_CMD_FOLLOWER_CTRL_AMPL_1_00     0x00
#define LCD_CMD_FOLLOWER_CTRL_AMPL_1_25     0x01
#define LCD_CMD_FOLLOWER_CTRL_AMPL_1_50     0x02
#define LCD_CMD_FOLLOWER_CTRL_AMPL_1_80     0x03
#define LCD_CMD_FOLLOWER_CTRL_AMPL_2_00     0x04
#define LCD_CMD_FOLLOWER_CTRL_AMPL_2_50     0x05
#define LCD_CMD_FOLLOWER_CTRL_AMPL_3_00     0x06
#define LCD_CMD_FOLLOWER_CTRL_AMPL_3_75     0x07

#define LCD_CMD_SET_DDRAM_ADDR              0x80

//  
void Display_Init (void);
void Display_Double_Font_Height (u8 d);
void Display_Clear (void);
void Display_Contrast (u8 c);
void Display_Cursor (u8 y, u8 x);
void Display_Dig (u8 d);
void Display_Char (char c);
void Display_Num (u32 n);
void Display_SNum (s32 n);
void Display_Str (char *s);
void Display_Str_P (const char *s);

#endif
