#include "Serial_Bus.h"

//   
u8 Busy = 0;
//    
u8 Total_Bits = 8;
//   
Serial_Bus_Bit_First_t Bit_First = MSB_First;


//    
inline static void Serial_Bus_Delay (void)
{
	_delay_us(5);
}


//   
void Serial_Bus_Init (void)
{
	SERIAL_BUS_DDR |= (1 << SERIAL_BUS_CS) | (1 << SERIAL_BUS_DAT) | (1 << SERIAL_BUS_WR) | (1 << SERIAL_BUS_RD);
	SERIAL_BUS_PORT |= (1 << SERIAL_BUS_CS) | (1 << SERIAL_BUS_DAT) | (1 << SERIAL_BUS_WR) | (1 << SERIAL_BUS_RD);
}


//    
//     ( 1  16),    
void Serial_Bus_Mode_Set (u8 totalbits, Serial_Bus_Bit_First_t bitfirst)
{
	if ((totalbits == 0) || (totalbits > 16)) return;
	Total_Bits = totalbits;
	Bit_First = bitfirst;
}


//       
void Serial_Bus_Chip_Select (void)
{
	Busy = 1;
	SERIAL_BUS_PORT &= ~(1 << SERIAL_BUS_CS);
	Serial_Bus_Delay();
}


//     
void Serial_Bus_Chip_DeSelect (void)
{
	Busy = 0;
	SERIAL_BUS_PORT |= (1 << SERIAL_BUS_CS);
	Serial_Bus_Delay();
}


//   
//   ,          
u8 Serial_Bus_Busy_Check (void)
{
	return Busy;
}


//  
void Serial_Bus_Send_Data (u16 Data)
{
	//     
	u16 Mask;
	//   
	u8 Bit_Count;
	//  "  "
	if (Bit_First == MSB_First)
	{
		Mask = (1 << (Total_Bits - 1));
		for (Bit_Count = 0; Bit_Count < Total_Bits; Bit_Count++)
		{
			if (Data & Mask) SERIAL_BUS_PORT |= (1 << SERIAL_BUS_DAT);
			else SERIAL_BUS_PORT &= ~(1 << SERIAL_BUS_DAT);
			Serial_Bus_Delay();
			SERIAL_BUS_PORT &= ~(1 << SERIAL_BUS_WR);
			Serial_Bus_Delay();
			SERIAL_BUS_PORT |= (1 << SERIAL_BUS_WR);
			Serial_Bus_Delay();
			Mask = Mask >> 1;
		}
	}
	//  "  "
	else
	{
		Mask = 0x0001;
		for (Bit_Count = 0; Bit_Count < Total_Bits; Bit_Count++)
		{
			if (Data & Mask) SERIAL_BUS_PORT |= (1 << SERIAL_BUS_DAT);
			else SERIAL_BUS_PORT &= ~(1 << SERIAL_BUS_DAT);
			Serial_Bus_Delay();
			SERIAL_BUS_PORT &= ~(1 << SERIAL_BUS_WR);
			Serial_Bus_Delay();
			SERIAL_BUS_PORT |= (1 << SERIAL_BUS_WR);
			Serial_Bus_Delay();
			Mask = Mask << 1;
		}
	}
}

